local helper = wesnoth.require("helper")
local utils = wesnoth.require("wml-utils")
local on_event = wesnoth.require("on_event")

local map_hexes = array_cartesian_product(initialize_array(21, identity), initialize_array(13, identity))

local campfires = { { 7,5 } , { 3,12 } , { 15, 5 }, { 19,12 }, } 

local function adjacent (x,y) 
    if x % 2 == 0 then return { { x - 1 , y }     , { x , y - 1 } , { x + 1 , y }     , { x + 1 , y + 1} , { x , y + 1 } , { x - 1 , y + 1 }, } end    
    if x % 2 == 1 then return { { x - 1 , y - 1 } , { x , y - 1 } , { x + 1 , y - 1 } , { x - 1 , y }    , { x , y + 1 } , { x + 1 , y }    , } end
end

local function is_campfire (x,y) 
    local response = false
    for_each_index(campfires, function(i,v) 
        if v[1] == x and v[2] == y then 
            response = true 
        end 
    end)
    return response
end

local function compare_array (a,b)
    return (a[1] == b[1] and a[2] == b[2])
end

function is_adjacent_to_campfire(x,y) 
    local adjacent_hexes = adjacent(x,y) 
    local response = false
    for_each_index(adjacent_hexes, function (i,v) 
        if array_match_compare_function(campfires, v, compare_array) == true then response = true end
    end) 
    return response
end

local adjacent_to_campfire_hexes = array_filter(map_hexes, function(i,v) return is_adjacent_to_campfire(v[1], v[2]) end)
print(adjacent_to_campfire_hexes)
print(is_adjacent_to_campfire(3,9))
for_each_index(adjacent_to_campfire_hexes, function (i,v) print(v) print(v[1]) print(v[2]) end)
local campfire = {"time", {red=28, green= 12, blue=-10, lawful_bonus=25},}

on_event("side_turn", function ()
    if wesnoth.current.side == 1 or wesnoth.current.side == 3 then
    
        for_each_index(campfires, function(i,v) 
            wesnoth.wml_actions.time_area { x = v[1] , y = v[2] , {"time", {red=25, green= 10, blue=-10, lawful_bonus=wesnoth.random(5)+25 },}, }
        end)
        
        for_each_index(adjacent_to_campfire_hexes, function (index, value)
            local x = value[1]
            local y = value[2]
            wesnoth.wml_actions.remove_time_area { id = tostring(x) .. "-" .. tostring(y) .. "-" .. "camp" }            
            if wesnoth.random() < 0.6 then
                local lawful_bonus_to_insert = math.min(wesnoth.get_time_of_day()["lawful_bonus"] + wesnoth.random(40), wesnoth.get_time_of_day()["lawful_bonus"] + wesnoth.random(40), 26)
                local next_to_campfire = { "time", { red = 20 , green = 5 , blue = -5 , lawful_bonus = lawful_bonus_to_insert } , }
                wesnoth.wml_actions.time_area { x = x , y = y , id = tostring(x) .. "-" .. tostring(y) .. "-" .. "camp" ,  next_to_campfire , }
            end                    
        end)
    end
end)
