local helper = wesnoth.require("helper")
local utils = wesnoth.require("wml-utils")
local on_event = wesnoth.require("on_event")

local x_range = { 1,2,3,4,5,6,7,8,9,10,11,13,14,15,16,17,18,19,20,21,22,23,}
local y_range = { 7,8,9,10,11,12,13,}

local map_hexes = array_cartesian_product(initialize_array(23, identity), initialize_array(19, identity))

local campfires = { { 4,9 } , { 11,10} , { 13,10 } , { 20, 9 }, { 2,14 }, { 6,15 }, { 10, 14 }, { 14,14 } , { 18,15 }, { 22, 14 }, } 

local function adjacent (x,y) 
    return { { x - 1 , y - 1 } , { x , y - 1 } , { x + 1 , y - 1 } , { x - 1 , y } , { x , y + 1 } , { x + 1 , y }, } 
end

local function is_campfire (x,y) 
    local response = false
    for_each_index(campfires, function(i,v) 
        if v[1] == x and v[2] == y then 
            response = true 
        end 
    end)
    return response
end

local function compare_array (a,b)
    return (a[1] == b[1] and a[2] == b[2])
end

function is_adjacent_to_campfire(x,y) 
    local adjacent_hexes = adjacent(x,y) 
    local response = false
    for_each_index(adjacent_hexes, function (i,v) 
        if array_match_compare_function(campfires, v, compare_array) == true then response = true end
    end) 
    return response
end

local adjacent_to_campfire_hexes = array_filter(map_hexes, function(i,v) return is_adjacent_to_campfire(v[1], v[2]) end)
print(adjacent_to_campfire_hexes)
print(is_adjacent_to_campfire(3,9))
for_each_index(adjacent_to_campfire_hexes, function (i,v) print(v) print(v[1]) print(v[2]) end)
local midnight = {"time", {id = "midnight", name = "Midnight", image = "misc/time-schedules/tod-schedule-24hrs.png~CROP(0,195,125,39)", red=-75, green=-45, blue=-13, lawful_bonus=-25 }}
local campfire = {"time", {red=25, green= 10, blue=-10, lawful_bonus=25},}

on_event("side_turn", function ()
    if wesnoth.current.side == 1 or wesnoth.current.side == 3 then
        for_each_index(x_range, function (index_x,x) 
            for_each_index(y_range, function (index_y,y) 
                if wesnoth.random() < 0.08 and is_campfire(x,y) == false then
                    wesnoth.wml_actions.time_area { x = x , y = y , id = tostring(x) .. "-" .. tostring(y), midnight, }
                end
                if wesnoth.random() < 0.08 and is_campfire(x,y) == false then 
                    wesnoth.wml_actions.remove_time_area { id = tostring(x) .. "-" .. tostring(y) }
                end
            end)
        end)
    
        for_each_index(campfires, function(i,v) 
            wesnoth.wml_actions.time_area { x = v[1] , y = v[2] , {"time", {red=25, green= 10, blue=-10, lawful_bonus=wesnoth.random(10)+25 },}, }
        end)
        
        for_each_index(adjacent_to_campfire_hexes, function (index, value)
            local x = value[1]
            local y = value[2]
            if wesnoth.random() < 0.4 then
                wesnoth.wml_actions.remove_time_area { id = tostring(x) .. "-" .. tostring(y) }
                local lawful_bonus_to_insert = math.max(wesnoth.get_time_of_day()["lawful_bonus"], 10 + wesnoth.random(15))
                local next_to_campfire = { "time", { red = 20 , green = 5 , blue = -5 , lawful_bonus = lawful_bonus_to_insert } , }
                wesnoth.wml_actions.time_area { x = x , y = y , id = tostring(x) .. "-" .. tostring(y) .. "-" .. "camp" ,  next_to_campfire , }
            else 
                wesnoth.wml_actions.remove_time_area { id = tostring(x) .. "-" .. tostring(y) .. "-" .. "camp" }
            end                    
        end)
    end
end)
