-- << laterlife/main_laterlife

local wesnoth = wesnoth
local laterlife = laterlife
local ipairs = ipairs
local string = string
local T = wesnoth.require("lua/helper.lua").set_wml_tag_metatable {}


local wave_length = 2  -- also change: experience_modifier in _main.cfg, text in about.txt
local new_wave_length = 3
local copy_strength_start = 32 -- point of no return is about 50%
local copy_strength_increase = 2


local human_side1, human_side2, human_side3, human_side4 = 1,3,5,7
local ai_side1, ai_side2, ai_side3, ai_side4 = 2,4,6,8
local sides = {
	[1] = { enemy_human = 3, enemy_clone = 2, half_owner = 1, is_human = true, order = 1 },
	[2] = { half_owner = 4, is_human = false },
	[3] = { enemy_human = 5, enemy_clone = 4, half_owner = 3, is_human = true, order = 2 },
	[4] = { half_owner = 1, is_human = false },
    [5] = { enemy_human = 7, enemy_clone = 6, half_owner = 5, is_human = true, order = 3 },
	[6] = { half_owner = 2, is_human = false },
	[7] = { enemy_human = 1, enemy_clone = 8, half_owner = 7, is_human = true, order = 4 },
	[8] = { half_owner = 3, is_human = false },
}

wesnoth.wml_actions.kill {
	canrecruit = true,
	side = ai_side1 .. "," .. ai_side2,
	fire_event = false,
	animate = false,
}
for _, side in ipairs(wesnoth.sides) do
	side.village_support = side.village_support + 2
end

wesnoth.wml_actions.event {
	name = "turn refresh",
	first_time_only = false,
	T.lua { code = "laterlife.turn_refresh()" }
}
wesnoth.wml_actions.event {
	name = "side turn end",
	first_time_only = false,
	T.lua { code = "laterlife.side_turn_end_event()" }
}

local function copy_units(from_side, to_side)
	for _, unit_original in ipairs(wesnoth.get_units { side = from_side }) do
		local percent = copy_strength_start + wesnoth.current.turn * copy_strength_increase
		local to_pos = laterlife.find_vacant(unit_original, 1 + (sides[to_side].order - 1) * 8, 8 + (sides[to_side].order - 1) * 8, true)
		if to_pos == nil then
			wesnoth.wml_actions.message {
				speaker = "narrator",
				message = "No free space to place a copy",
			}
			laterlife.endlevel_winner(from_side, sides[from_side].enemy_human)
			break
		else
			laterlife.copy_unit(unit_original, to_pos, to_side, percent)
		end
	end
end


function laterlife.new_turn ()
    if wesnoth.current.turn % 5 == 1 or wesnoth.current.turn % 5 == 4 then
		copy_units(human_side2, ai_side1)
		copy_units(human_side1, ai_side2)
    end
function laterlife.turn_refresh()
		if sides[wesnoth.current.side].is_human == false then
			laterlife.unpetrify_units()
		end
	end
	-- print("turn", wesnoth.current.turn, "side", wesnoth.current.side, "div", (wesnoth.current.turn - 2) % wave_length)
	local next_wave_turn = wesnoth.current.turn
		- (wesnoth.current.turn - 2) % wave_length
		+ wave_length - 1
	wesnoth.wml_actions.label {
		x = 16,
		y = 2,
		text = string.format("<span color='#FFFFFF'>Next wave:\n    turn %s</span>", next_wave_turn)
	}
end

function laterlife.side_turn_end_event()
	for _, unit in ipairs(wesnoth.get_units { canrecruit = true, side = wesnoth.current.side }) do
		unit.status.uncovered = true
	end
end


-- >>
