local wesnoth = wesnoth
local laterlife = laterlife
local ipairs = ipairs
local string = string
local T = wesnoth.require("lua/helper.lua").set_wml_tag_metatable {} 

local width, height, border = wesnoth.get_map_size()

width = (width - 1) * 0.5

local mutation_probability = 0.25

local select_random_array_index(array)
    return array[wesnoth.random(#array)]
end

local mutation_table = {
    { {6,4}, {"Wog", "Sm", "Wwrg"}, },
    { {5,6}, {"Wo", "Wwf"}, },    
    { {2,4}, {"Wwrg", "Wwf", "Dd", "Gxua"}, },    
    { {2,6}, {"Wwrg", "Ss", "Gll", "Uu"}, },
    { {4,6}, {"Gd^Fp", "Wwf", "Dd", "Sm", "Gd^Uf"}, },    
    { {3,6}, {"Gll^Fp", "Dd", "Hhd", "Hhd^Uf","Gll"}, },
    { {8,6}, {"Ss", "Wwf", "Wwrg", "Gxua"}, },    
    { {3,7}, {"Gll^Fp", "Hhd", "Uu", "Uu^Uf", "Hhd^Fp", "Wwf", "Gll"}, },
    { {1,7}, {"Gll^Fp", "Hhd", "Ss", "Wwf", "Gll", "Wwrg"}, },
    { {3,8}, {"Hh", "Hhd", "Hh^Fp", "Hhd^Fp", "Hh^Uf", "Gg^Uf", "Dd","Ss"}, },    
    { {4,8}, {"Gd", "Hhd", "Dd"}, },    
    { {5,8}, {"Hhd^Fp", "Gll^Fp", "Dd^Do", "Gll"}, },
    { {6,7}, {"Sm", "Wog", "Wo", "Dd", "Gll", "Hhd", "Hhd^Uf"}, },
    { {8,7}, {"Wog", "Wo", "Gll", "Gll^Fp"}, },
    { {6,8}, {"Wo", "Sm", "Ss", "Dd", "Rb", "Wwrg"}, },    
    { {7,8}, {"Wo", "Sm", "Ss", "Dd", "Rb", "Wwrg"}, },    
    { {8,8}, {"Hh", "Gll^Fp", "Ss", "Hh^Uf", "Ss^Fp"}, },    
    { {6,9}, {"Hh^Fp", "Gg", "Gg^Uf", "Hh^Uf", "Dd^Do"}, },
    { {1,9}, {"Gg", "Hh", "HH^Fp", "Dd", "Wo"}, },    
    { {2,9}, {"Dd", "Gg", "Gd^Uf", "Gg^Fp", "Hh", "Hh^Fp"}, },    
    { {1,10}, {"Hh", "Gd^Fp", "Ss", "Hh^Uf"}, },
    { {2,10}, {"Gg", "Ss", "Hh^Fp", "Uu", "Ss^Fp", "Wo"}, },    
    { {3,10}, {"Ss", "Ss^Fp", "Gd^Fp", "Hh^Fp", "Gd^Uf"}, },
    { {4,10}, {"Sm", "Ss", "Wwf"}, },
    { {1,11}, {"Gg", "Mm", "Hh", "Gg^Fp", "Hh^Fp", "Hh^Uf"}, },    
    { {3,11}, {"Mm", "Hh^Fp", "Ss^Fp", "Ss", "Gg^Fp", "Dd", "Sm"}, },    
    { {5,11}, {"Sm", "Wo"}, },
    { {3,12}, {"Dd", "Mm", "Gg"}, },
}

function get_mirror (x) 
    return width + 2 - (x - width) 
end
    
function apply_mutation (table_row)
    local x = table_row[1][1]
    local x2 = get_mirror(x)
    local y = table_row[1][2]
    local types_array = table_row[2]
    local selected = select_random_array_index(types_array)
    wesnoth.set_terrain(x,y, selected)
    wesnoth.set_terrain(x2,y,selected)
end

for_each_index(mutation_table, function (index, element) 
    if wesnoth.random() < mutation_probability then
        apply_mutation(element)
    end
end)
